<script>
  import FullCalendar, { Draggable } from "svelte-fullcalendar";
  import daygridPlugin from "@fullcalendar/daygrid";
  import timegridPlugin from "@fullcalendar/timegrid";
  import interactionPlugin from "@fullcalendar/interaction";

  let options = {
    dateClick: handleDateClick,
    droppable: true,
    editable: true,
    events: [
      // initial event data
      { title: "Today", start: new Date() },
      { title: "Yanking the weeds out", start: "2022-06-30" },
      { title: "Tomatoes seeding", start: "2022-03-10" },
    ],
    eventColor: "var(--supla-green)",
    eventTextColor: "black",
    initialView: "dayGridMonth",
    plugins: [daygridPlugin, timegridPlugin, interactionPlugin],
    headerToolbar: {
      left: "prev,next today",
      center: "title",
      right: "dayGridMonth,timeGridWeek,timeGridDay",
    },
    height: "100%",
    weekends: true,
  };
  let calendarComponentRef;
  let eventData = { title: "watering", duration: "00:05" };

  function toggleWeekends() {
    options = { ...options, weekends: !options.weekends };
  }

  function gotoPast() {
    let calendarApi = calendarComponentRef.getAPI();
    calendarApi.gotoDate("2022-03-10"); // call a method on the Calendar object
  }

  function handleDateClick(event) {
    if (
      confirm("Would you like to add an seeding to " + event.dateStr + " ?")
    ) {
      const { events } = options;
      const calendarEvents = [
        ...events,
        {
          title: "Seeding",
          start: event.date,
          allDay: event.allDay,
        },
      ];
      options = {
        ...options,
        events: calendarEvents,
      };
    }
  }
</script>

<svelte:head>
  <title>Calendar</title>
</svelte:head>

<div class="demo-app">
  <div class="demo-app-calendar">
    <FullCalendar bind:this={calendarComponentRef} {options} />
  </div>
</div>

<div class="demo-app-top">
  <button on:click={toggleWeekends}>toggle weekends</button> &nbsp;
  <button on:click={gotoPast}>go to last seeding</button> &nbsp; (also, click a date/time
  to add an seeding)
</div>

<div>
  <Draggable {eventData} class="draggable">Register the watering</Draggable>
</div>

<!-- <script context="module"> -->
<!-- 	import { browser, dev } from '$app/env'; -->

<!-- 	// we don't need any JS on this page, though we'll load -->
<!-- 	// it in dev so that we get hot module replacement... -->
<!-- 	export const hydrate = dev; -->

<!-- 	// ...but if the client-side router is already loaded -->
<!-- 	// (i.e. we came here from elsewhere in the app), use it -->
<!-- 	export const router = browser; -->

<!-- 	// since there's no dynamic data here, we can prerender -->
<!-- 	// it so that it gets served as a static asset in prod -->
<!--   export const prerender = true; -->

<!--   // import calendar from './calendar/calendar.svelte' -->

<!--   //     let days=[] -->
<!--   // for (let i=1, i < 30, i++) -->
<!--   // { -->
<!--   //   let day = i -->
<!--   //   days.push(i) -->
<!--   // } -->

<!-- </script> -->

<!-- <svelte:head> -->
<!-- 	<title>CALENDAR</title> -->
<!-- 	<meta name="description" content="About this app" /> -->
<!-- </svelte:head> -->

<!-- <div class="content"> -->

<!-- <div class="month"> -->
<!--   <ul> -->
<!--     <li class="prev">&#10094;</li> -->
<!--     <li class="next">&#10095;</li> -->
<!--     <li>August<br><span style="font-size:18px">2021</span></li> -->
<!--   </ul> -->
<!-- </div> -->

<!-- <ul class="weekdays"> -->
<!--   <li>Mo</li> -->
<!--   <li>Tu</li> -->
<!--   <li>We</li> -->
<!--   <li>Th</li> -->
<!--   <li>Fr</li> -->
<!--   <li>Sa</li> -->
<!--   <li>Su</li> -->
<!-- </ul> -->

<!-- <ul class="days"> -->
<!--   <li>1</li> -->
<!--   <li>2</li> -->
<!--   <li>3</li> -->
<!--   <li>4</li> -->
<!--   <li>5</li> -->
<!--   <li>6</li> -->
<!--   <li>7</li> -->
<!--   <li>8</li> -->
<!--   <li>9</li> -->
<!--   <li><span class="active">10</span></li> -->
<!--   <li>11</li> -->

<!-- </ul> -->

<!-- 	<p> -->
<!-- 		This is a <a href="https://kit.svelte.dev">SvelteKit</a> app. You can make your own by typing the -->
<!-- 		following into your command line and following the prompts: -->
<!-- 	</p> -->

<!-- 	<pre>npm init svelte</pre> -->

<!-- 	<p> -->
<!-- 		The page you're looking at is purely static HTML, with no client-side interactivity needed. -->
<!-- 		Because of that, we don't need to load any JavaScript. Try viewing the page's source, or opening -->
<!-- 		the devtools network panel and reloading. -->
<!-- 	</p> -->

<!-- 	<p> -->
<!-- 		The <a href="/todos">TODOs</a> page illustrates SvelteKit's data loading and form handling. Try using -->
<!-- 		it with JavaScript disabled! -->
<!-- 	</p> -->
<!-- </div> -->

<!-- <style> -->
<!-- 	.content { -->
<!-- 		width: 100%; -->
<!-- 		max-width: var(--column-width); -->
<!-- 		margin: var(--column-margin-top) auto 0 auto; -->
<!-- 	} -->

<!-- 	/* calendar	 */ -->

<!-- 	ul {list-style-type: none;} -->
<!-- body {font-family: Verdana, sans-serif;} -->

<!-- /* Month header */ -->
<!-- .month { -->
<!--   padding: 70px 25px; -->
<!--   width: 100%; -->
<!--   background: var(--supla-green); -->
<!--   text-align: center; -->
<!-- } -->

<!-- /* Month list */ -->
<!-- .month ul { -->
<!--   margin: 0; -->
<!--   padding: 0; -->
<!-- } -->

<!-- .month ul li { -->
<!--   color: white; -->
<!--   font-size: 20px; -->
<!--   text-transform: uppercase; -->
<!--   letter-spacing: 3px; -->
<!-- } -->

<!-- /* Previous button inside month header */ -->
<!-- .month .prev { -->
<!--   float: left; -->
<!--   padding-top: 10px; -->
<!-- } -->

<!-- /* Next button */ -->
<!-- .month .next { -->
<!--   float: right; -->
<!--   padding-top: 10px; -->
<!-- } -->

<!-- /* Weekdays (Mon-Sun) */ -->
<!-- .weekdays { -->
<!--   margin: 0; -->
<!--   padding: 10px 0; -->
<!--   background-color:#ddd; -->
<!-- } -->

<!-- .weekdays li { -->
<!--   display: inline-block; -->
<!--   width: 13.6%; -->
<!--   color: #666; -->
<!--   text-align: center; -->
<!-- } -->

<!-- /* Days (1-31) */ -->
<!-- .days { -->
<!--   padding: 10px 0; -->
<!--   background: #eee; -->
<!--   margin: 0; -->
<!-- } -->

<!-- .days li { -->
<!--   list-style-type: none; -->
<!--   display: inline-block; -->
<!--   width: 13.6%; -->
<!--   text-align: center; -->
<!--   margin-bottom: 5px; -->
<!--   font-size:12px; -->
<!--   color: #777; -->
<!-- } -->

<!-- /* Highlight the "current" day */ -->
<!-- .days li .active { -->
<!--   padding: 5px; -->
<!--   background: var(--supla-green); -->
<!--   color: white !important -->
<!-- } -->

<!-- </style> -->

<style>
  /* :global(* > *) { */
  /* 	padding: 0; */
  /* 	margin: 0; */
  /* 	box-sizing: border-box; */
  /* } */

  @media screen and (min-width: 1080px) {
    .demo-app {
      padding-right: 50vw;
    }
  }

  @media screen and (max-width: 720px) {
    .demo-app {
      padding-top: 20vh;
    }
  }

  .demo-app {
    width: 100vw;
    height: 100vh;
    padding: 0.5rem;
    padding-right: 25vw;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    font-family: Arial, Helvetica Neue, Helvetica, sans-serif;
    font-size: 14px;
  }

  .demo-app-calendar {
    width: 100%;
    flex-grow: 1;
    margin: 0 auto;
    max-width: 900px;
    align: center;
  }
  :global(.draggable) {
    color: white;
    background: var(--supla-green);
    border-radius: 100px;
    border-style: solid;
    border-color: black;
    width: fit-content;
    padding: 1rem;
    margin: 1rem;
    cursor: pointer;
  }
</style>
